#include<reg52.h>
#include<intrins.h>
#define uint unsigned int
#define uchar unsigned char
uchar LCD[6];   //ѹתLCD1602Һַʾ
uint Volt;
sbit DO  = P1^0;	//ʱ
sbit CS  = P1^1;	//Ƭѡ
sbit CLK = P1^2;	//
sbit RS = P2^0;			//1602Һ/ѡ
sbit RW = P2^1;			//1602Һд
sbit E  = P2^2;			//1602Һʹܶ

// Function Prototypes
void check_busy(void);
void write_command(uchar com);
void write_date(uchar date);
void LCD_init(void);
void string(uchar ad ,uchar *s);
//void lcd_test(void);
void delay(uint);
void Volt_To_LCD1602(void);
void delay_ms(uint xms);
void Data_Conversion(void);
uchar TLC549_ADC(void);
/*******************************************
    LCD1602 Driver mapped as IO peripheral
*******************************************/  
// Delay
// Delay
void delay(uint j)
{ 
	uchar i = 60;
  for(; j>0; j--)
  { 
		while(--i);
    i = 59;
    while(--i);
    i = 60;
  }
}

// Test the Busy bit
void check_busy(void)
{ 
	do
  { 
		P0 = 0xff;
    E = 0;
    RS = 0; 
    RW = 1;
    E = 1;
    _nop_();
  } while(P0 & 0x80);
  E = 0;
}

// Write a command
void write_command(uchar com)
{ 
	check_busy();
  E = 0;
  RS = 0;
  RW = 0;
  P0 = com;
  E = 1;
  _nop_();
  E = 0;
  delay(1);
 }

// Write Data
void write_date(uchar date)
{ 
	check_busy();
  E = 0;
  RS = 1;
  RW = 0;
  P0 = date;
  E = 1;
  _nop_();
  E = 0;
  delay(1);   
}

// Initialize LCD controller
void LCD_init(void)
{ 
	write_command(0x38); // 8-bits, 2 lines, 7x5 dots
  write_command(0x0C); // no cursor, no blink, enable display
  write_command(0x06); // auto-increment on
  write_command(0x01); // clear screen
  delay(1);
}

// Display a string
void string(uchar ad, uchar *s)
{ 
	write_command(ad);
  while(*s>0)
  { 
		 write_date(*s++);
     delay(100);
  }
}
//****************************************************//
//:delay_ms(uint xms)
//:msʱ
//***************************************************//

void delay_ms(uint xms)
{
	uint x,y;
	for(x=xms;x>0;x--)
		for(y=110;y>0;y--);
	
}

//***************************************************//
//:TLC549_ADC()
//:ȡһA/Dת,һA/Dת
//**************************************************//
uchar TLC549_ADC(void)
{
	uchar n, tmp;
 
	CS  = 1;                     //CSø,ƬѡЧ
	CLK = 0;

	CS  = 0;                     //CSõ,ƬѡЧ,ͬʱDOλ
	_nop_();
	_nop_();                     //ʵӳʱ1.4us Setup Time

	for(n = 0; n < 8; n++) //λ
	{ 
		tmp <<= 1;
		tmp |=  DO;
  
		CLK = 1;        //0.4us
		_nop_();          //CLK transition time Max 0.1us
		CLK = 0;        //0.4us 
	}
	CS = 1;            //CSø,ƬѡЧ
	for(n = 17; n != 0; n--) _nop_();  //Next CoversionҪӳ17us
	return (tmp);
}
//****************************************//
//:Data_Conversion()
//:ѹ
//*****************************************//
void Data_Conversion(void)
{
	uchar AD_Data;

	AD_Data = TLC549_ADC();
	delay_ms(1000);
	Volt = 5.0 / 256 * AD_Data*1000;
}

void Volt_To_LCD1602(void)
{ 
	Data_Conversion();                     //ѹ㲢Ŵ1000
	LCD[0] = Volt/1000;         //ǧλ
	LCD[1] = '.';                                //С
	LCD[2] = Volt/100%10;  //λ
	LCD[3] = Volt/10%10;    //ʮλ
	LCD[4] = Volt%10;           //λ
	LCD[5] = 'V';                              //ַV 
                              
	write_command(0x80+8);
	write_date(0x30+LCD[0]);
	write_date(LCD[1]);
	write_date(0x30+LCD[2]);
	write_date(0x30+LCD[3]);
	write_date(0x30+LCD[4]);
	write_date(LCD[5]);

}
	
int main()
{
	//uint m;
	LCD_init(); 
	
  delay(100); 
  write_command(0x01);
	write_command(0x80);
	string(0x80,"Voltage:");
	delay_ms(2000);



	while(1)
	{
		Volt_To_LCD1602();
		
	}
	
}